package net.vpnsdk.demo.ui;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.support.v4.app.ActivityCompat;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.android.common.utils.SpUtils;
import com.android.qmui.activity.ListActivity;
import com.android.qmui.constant.QMUIConstant;

import net.vpnsdk.demo.R;
import net.vpnsdk.demo.config.MotionProConstant;
import net.vpnsdk.demo.sim.SimInputFinishCallback;
import net.vpnsdk.vpn.Common;
import net.vpnsdk.vpn.Common.LogLevel;
import net.vpnsdk.vpn.Common.VpnError;
import net.vpnsdk.vpn.Common.VpnMsg;
import net.vpnsdk.vpn.SDKConfig;
import net.vpnsdk.vpn.VPNAccount;
import net.vpnsdk.vpn.VPNManager;
import net.vpnsdk.vpn.VPNManager.AAAMethod;
import net.vpnsdk.vpn.Version;
import net.vpnsdk.demo.sim.GetSimInfoUtil;

import java.io.DataInputStream;
import java.io.FileOutputStream;

import net.vpnsdk.demo.sim.InputSimInfoActivity;

import static java.lang.Integer.parseInt;

public class MainActivity extends Activity {

    private static AAAMethod[] mMethods = null;
    SharedPreferences mPerferences = null;
    Button mButtonLaunch;
    EditText mTextServer, mTextMethod, mTextUser, mTextPass;
    TextView mStatus, mDeviceId;
    private String Tag = "VPNSDKDemo";
    private Thread mThreadStartVpn = null;
    private Thread mThreadStopVpn = null;
    private VPNAccount account;
    private String host = "";
    private int port = 443;
    private String selected_ip = "";
    private int ip_time_ms = 99999;
    //点击按钮后启动或停止VPN
    private OnClickListener mButtonListener = new OnClickListener() {
        public void onClick(View v) {
            if(SDKConfig.IS_SKF && VPNManager.getInstance().getStatus() == Common.VpnStatus.IDLE){
                GetSimInfoUtil.getSimInfo(MainActivity.this);
                InputSimInfoActivity.jump(MainActivity.this, -1, new SimInputFinishCallback() {
                    @Override
                    public void inputFinish() {
                        connect();
                    }
                });
                return;
            }
            connect();
        }
    };
    private Button sslProtocol;
    private final int TO_LIST_REQUEST_CODE = 200;
    private int sslPosition;

    private void connect() {
        doSave();
        int status = VPNManager.getInstance().getStatus();
        Log.i(Tag, "vpn status: " + status);

        if (status == Common.VpnStatus.IDLE) {
            // 启动VPN
            String server = mTextServer.getText().toString();
            server = server.trim().replace(" ", "");
            Log.d("ArrayTmp","server:"+server);
            if(server.contains("@")){
                host = server; //10.8.7.123:443@10.8.7.124:8443  //10.8.7.123@10.8.7.124:8443  //10.8.7.123@10.8.7.124
                port = 443;  //set as default value, the really port will be found from c-sdk.
            }else if(server.contains(";")) {//multi-host input for server
                final String[] servers = server.split(";");
                for(int i= 0; i < servers.length; i++) {
                    final int finalI = i;
                    new Thread(new Runnable() {
                        public void run() {
                            String host_port = servers[finalI];
                            String h = "";
                            int p = 443;
                            if(host_port.contains(":")) {// parse port input
                                h = host_port.split(":")[0];
                                try {
                                    p = parseInt(host_port.split(":")[1]);
                                } catch (NumberFormatException e) {
                                    Toast.makeText(MainActivity.this, "输入端口号有误！", Toast.LENGTH_SHORT).show();
                                    return;
                                }
                            } else {
                                h = host_port;
                            }
                            Log.d("ArrayTmp","host:"+h+";port:"+p);
                            String[] ret = VPNManager.getInstance().getHostConnTime(h, p);
                            Log.d("ArrayTmp","ret length:"+ret.length);
                            if (ret != null && ret.length == 3){
                                String ret0 = ret[0];
                                String ret1 = ret[1];
                                String ret2 = ret[2];
                                Log.d("ArrayTmp","ret0:"+ret0);
                                Log.d("ArrayTmp","ret1:"+ret1);
                                Log.d("ArrayTmp","ret2:"+ret2);
                                String ip = "";
                                int time = 0;
                                if (ret0 != null && ret0.length() > 1 && ret0.contains("#")) {
                                    String[] r0 = ret0.split("#");
                                    ip = r0[0];
                                    try {
                                        time = parseInt(r0[1]);
                                    } catch (NumberFormatException e) {
                                        Toast.makeText(MainActivity.this, "输入端口号有误！", Toast.LENGTH_SHORT).show();
                                        return;
                                    }
                                }
                                if (ret1 != null && ret1.length() > 1 && ret1.contains("#")) {
                                    String[] r1 = ret1.split("#");
                                    int time1 = 99999;
                                    try {
                                        time1 = parseInt(r1[1]);
                                    } catch (NumberFormatException e) {
                                        Toast.makeText(MainActivity.this, "输入端口号有误！", Toast.LENGTH_SHORT).show();
                                        return;
                                    }
                                    if (time > time1) {
                                        ip = r1[0];
                                        time = time1;
                                    }
                                }
                                if (ret2 != null && ret2.length() > 1 && ret2.contains("#")) {
                                    String[] r2 = ret2.split("#");
                                    int time2 = 99999;
                                    try {
                                        time2 = parseInt(r2[1]);
                                    } catch (NumberFormatException e) {
                                        Toast.makeText(MainActivity.this, "输入端口号有误！", Toast.LENGTH_SHORT).show();
                                        return;
                                    }
                                    if (time > time2) {
                                        ip = r2[0];
                                        time = time2;
                                    }
                                }
                                if( time < ip_time_ms) {
                                    setIpTimeHostPort(ip, time, h, p);
                                }
                            }
                        }
                    }).start();
                }
            }else{//single host case
                if(server.contains(":")) {// parse port input
                    host = server.split(":")[0];
                    try {
                        port = parseInt(server.split(":")[1]);
                    } catch (NumberFormatException e) {
                        Toast.makeText(MainActivity.this, "输入端口号有误！", Toast.LENGTH_SHORT).show();
                        return;
                    }
                } else {
                    host = server;
                }
            }
            String user = mTextUser.getText().toString().trim();
            String pass = mTextPass.getText().toString();
            int flag = VPNManager.VpnFlag.VPN_FLAG_NATIVE_L3VPN;
            if(SDKConfig.IS_SKF){
                flag = VPNManager.VpnFlag.VPN_FLAG_LOGIN_ONLY
                        | VPNManager.VpnFlag.VPN_FLAG_MOTIONPRO_V2
                        | VPNManager.VpnFlag.VPN_FLAG_LOGOUT_DEV_SESSION
                        | VPNManager.VpnFlag.VPN_FLAG_SKIP_LOGOUT
                        | VPNManager.VpnFlag.VPN_FLAG_DESKTOP_DIRECT;
            }
            //account = new VPNAccount();
            //account.setFlag(flag);
            //account.setHost(server);
            //account.setUsername(user);
            //account.setPassword(pass);
            //account.setVerifySvrCert(false);
            //account.setCertPass("123456");
            //account.setCertPath(getFilesDir() + "/rsaclient.p12");

            //不需要证书的情况,证书路径和证书密码为空即可
            //start(server, 443, user, pass, "", "", flag);


            // 商密证书的情况
            /*
             * rsaclient.p12 rsa证书， 密码123456
             * */
            //start(server, 443, user, pass, getFilesDir() + "/rsaclient.p12", "123456", flag);

            // 国密证书的情况
            /*
             * 国密证书有一般有两个文件（PFX格式，后缀是pfx或p12），一个用作加密，一个用作签名，两个文件名用'|'分割，密码用'\n'分割。
             * 也可以只传递一个证书文件和一个密码，即用作加密，也用作签名，传递一个证书文件时不需要用分隔符分割，
             * 传递一个密码时也不需要用分隔符分割。
             * sm2agclientenc.p12 加密证书， 密码123456
             * sm2agclientsign.p12 签名证书， 密码654321
             * */
            //start(server, 443, user, pass, getFilesDir() + "/sm2agclientenc.p12|" + getFilesDir() + "/sm2agclientsign.p12", "123456\n654321", flag);
            //start(server, 443, user, pass, getFilesDir() + "/sm2agclientenc.p12" , "123456", flag);
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            Log.d("ArrayTmp", "before start - host:"+host+";fastest_ip:"+selected_ip+";port:"+port);
            start(host, port, user, pass, "", "", flag);
        } else {
            // 停止VPN
            stop();
        }
    }

    private synchronized void setIpTimeHostPort(String ip, int time, String host, int port ){
        this.port = port;
        this.selected_ip = ip;
        this.ip_time_ms = time;
        this.host = host;
    }
    /**
     * 处理VPN的各种消息
     */
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            Log.i(Tag, "handleMessage " + msg.what);
            switch (msg.what) {
                case VpnMsg.MSG_VPN_CONNECTING:
                    Log.i(Tag, "vpn connecting");
                    mStatus.setText("VPN is connecting...");
                    mButtonLaunch.setText("Disconnect");
                    break;
                case VpnMsg.MSG_VPN_CONNECTED:
                    Log.i(Tag, "vpn connected ");
                    mStatus.setText("VPN connected.");
                    mButtonLaunch.setText("Disconnect");

                    break;
                case VpnMsg.MSG_VPN_DISCONNECTING:
                    Log.i(Tag, "vpn disconnecting ");
                    mStatus.setText("VPN is disconnecting...");
                    break;
                case VpnMsg.MSG_VPN_DISCONNECTED:
                    Log.i(Tag, "vpn disconnected");
                    mStatus.setText("VPN is not running.");
                    mButtonLaunch.setText("Connect");
                    showError(msg.getData().getInt(VpnMsg.MSG_VPN_ERROR_CODE));
                    break;
                case VpnMsg.MSG_VPN_CONNECT_FAILED:
                    Log.i(Tag, "vpn connect failed");
                    mStatus.setText("VPN is not running.");
                    mButtonLaunch.setText("Connect");
                    showError(msg.getData().getInt(VpnMsg.MSG_VPN_ERROR_CODE));
                    break;
                case VpnMsg.MSG_VPN_RECONNECTING:
                    Log.i(Tag, "vpn reconnecting");
                    mStatus.setText("VPN is reconnecting...");
                    break;
                case VpnMsg.MSG_VPN_LOGIN:
                    int error = msg.getData().getInt(VpnMsg.MSG_VPN_ERROR_CODE);
                    mMethods = (AAAMethod[]) (msg.obj);
                    if (0 == mMethods.length) {
                        VPNManager.getInstance().cancelLogin();
                    }
                    handleLogin(error);
                    break;
                case VpnMsg.MSG_VPN_DEVREG:
                    mMethods = (AAAMethod[]) (msg.obj);
                    handleDevReg();
                    break;
                default:
                    super.handleMessage(msg);
            }
        }
    };

    public static AAAMethod[] getMethods() {
        return mMethods;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);

        mButtonLaunch = (Button) findViewById(R.id.buttonVPN);
        mButtonLaunch.setOnClickListener(mButtonListener);
        mTextServer = (EditText) findViewById(R.id.textServer);
        mTextMethod = (EditText) findViewById(R.id.method);
        mTextUser = (EditText) findViewById(R.id.textUser);
        mTextPass = (EditText) findViewById(R.id.textPass);
        mStatus = (TextView) findViewById(R.id.textStatus);
        mDeviceId = (TextView) findViewById(R.id.textDeviceId);
        sslProtocol = findViewById(R.id.ssl_protocol);

        mPerferences = PreferenceManager.getDefaultSharedPreferences(this);
        String value = mPerferences.getString("host", mTextServer.getText()
                .toString());
        mTextServer.setText(value);
        value = mPerferences.getString("user", "");
        mTextUser.setText(value);
        value = mPerferences.getString("pass", "");
        mTextPass.setText(value);
        VPNManager.initialize(this).setHandler(mHandler);
        VPNManager.getInstance().setLogLevel(LogLevel.LOG_DEBUG, 0);
        //bind 服务，不bind则无法启动VPN
        VPNManager.getInstance().bindVPNService("net.vpnsdk.vpn.VPN_SERVICE");
        //把证书复制到一个临时文件中
        saveRawResourceToFile(R.raw.rsaclient, "rsaclient.p12");
        saveRawResourceToFile(R.raw.sm2agclientenc, "sm2agclientenc.p12");
        saveRawResourceToFile(R.raw.sm2agclientsign, "sm2agclientsign.p12");
        Log.i(Tag, "SDK version: " + Version.VERSION + "\n" + "Build Date: " + Version.BUILD_DATE);

        sslProtocol.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                ListActivity.toListActivity(MainActivity.this,TO_LIST_REQUEST_CODE);
            }
        });

        if(SDKConfig.IS_SKF) SpUtils.getInstence().saveInt(MotionProConstant.SP_KEY_SSL_AGREEMENT,3);
        showUI(SpUtils.getInstence().getInt(MotionProConstant.SP_KEY_SSL_AGREEMENT));
        ActivityCompat.requestPermissions((Activity) this, new String[]{Manifest.permission.READ_PHONE_STATE}, 1);
    }

    private void doSave() {
        SharedPreferences.Editor editor = mPerferences.edit();

        String value = mTextServer.getText().toString().trim();
        editor.putString("host", value);

        value = mTextUser.getText().toString().trim();
        editor.putString("user", value);

        value = mTextPass.getText().toString();
        editor.putString("pass", value);

        value = mTextMethod.getText().toString();
        editor.putString("method", value);

        editor.commit();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.d(Tag, "onActivityResult");

        if(requestCode == TO_LIST_REQUEST_CODE){
            if(data!=null){
                sslPosition = data.getIntExtra("result",-1);
                SpUtils.getInstence().saveInt(MotionProConstant.SP_KEY_SSL_AGREEMENT,sslPosition);
                showUI(sslPosition);
            }
            return;
        }

        VPNManager.getInstance().onActivityResult(requestCode, resultCode);

        //if (account.getHost().length() > 0 ){
        //	start(account.getHost(), account.getPort(), account.getUsername(), account.getPassword(), account.getCertPath(), account.getCertPass(), account.getFlag());
        //}
    }

    private void showUI(int position){
        if(position == -1) position = 0;
        if(position < 0) return;
        sslProtocol.setText(getString(R.string.ssl_protocol) + QMUIConstant.SSL_AGREEMENT_DATAS[position]);
    }

    public void onDestroy() {
        Log.d(Tag, "onDestroy");
        doSave();

        super.onDestroy();
    }

    public void OnPause() {
        super.onPause();
        Log.d(Tag, "OnPause");

        doSave();
    }

    public void doInit() {
        int status = VPNManager.getInstance().getStatus();
        if (status == Common.VpnStatus.CONNECTED) {
            mStatus.setText("VPN connected.");
            mButtonLaunch.setText("Disconnect");
        } else if (status == Common.VpnStatus.CONNECTING) {
            mStatus.setText("VPN is connecting.");
            mButtonLaunch.setText("Disconnect");
        } else if (status == Common.VpnStatus.DISCONNECTING) {
            mStatus.setText("VPN is disconnecting.");
            mButtonLaunch.setText("Disconnect");
        } else if (status == Common.VpnStatus.IDLE) {
            mStatus.setText("VPN is not running.");
            mButtonLaunch.setText("Connect");
        } else if (status == Common.VpnStatus.RECONNECTING) {
            mStatus.setText("VPN is not running.");
            mButtonLaunch.setText("Disconnect");
        }
    }

    public void onResume() {
        super.onResume();
        doInit();
    }

    // 保存资源到文件中
    private void saveRawResourceToFile(int id, String filename) {
        Log.d(Tag, "file dir is " + getFilesDir());
        DataInputStream in = new DataInputStream(getResources().openRawResource(id));
        try {
            try {
                FileOutputStream outputStream = openFileOutput(filename, Context.MODE_PRIVATE);
                byte[] buf = new byte[8192];
                int len;
                while ((len = in.read(buf)) > 0) {
                    outputStream.write(buf, 0, len);
                }
                outputStream.close();
                in.close();
            } catch (Exception e) {
            }
        } finally {
        }
    }

    private void createCertFile() {
        Log.d(Tag, "dir is " + getFilesDir());
        DataInputStream in = new DataInputStream(getResources().openRawResource(R.raw.rsaclient));
        try {
            try {
                FileOutputStream outputStream = openFileOutput("client.p12", Context.MODE_PRIVATE);
                byte[] buf = new byte[8192];
                int len;
                while ((len = in.read(buf)) > 0) {
                    outputStream.write(buf, 0, len);
                }
                outputStream.close();
                in.close();
            } catch (Exception e) {
            }
        } finally {
        }
    }

    /**
     * 启动
     */
    public void start(String host, int port, String username, String password,
                      String certpath, String certpass, int flag) {
        if (mThreadStartVpn != null) {
            Log.w(Tag, "ThreadStartVpn is not null, will kill it!");
            mThreadStartVpn.interrupt();
            try {
                mThreadStartVpn.join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            mThreadStartVpn = null;
        }
        mThreadStartVpn = new StartVpnThread(host, port, username, password,
                certpath, certpass, flag);

        mThreadStartVpn.start();
    }

    /**
     * 停止
     */
    public void stop() {
        if (Common.VpnStatus.IDLE == VPNManager.getInstance().getStatus()) {
            return;
        }
        if (mThreadStopVpn != null) {
            Log.w(Tag, "ThreadStopVpn is not null, will kill it.");
            mThreadStopVpn.interrupt();
            try {
                mThreadStopVpn.join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            mThreadStopVpn = null;
        }

        if (mThreadStartVpn != null) {
            Log.w(Tag, "ThreadStartVpn is not null, will kill it!");
            mThreadStartVpn.interrupt();
            try {
                mThreadStartVpn.join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            mThreadStartVpn = null;
        }

        mThreadStopVpn = new Thread(new Runnable() {
            public void run() {
                VPNManager.getInstance().stopVPN();
                mThreadStopVpn = null;
            }
        });

        mThreadStopVpn.start();
    }

    private void handleLogin(int error) {
        Intent intent = new Intent(this, LoginActivity.class);
        intent.putExtra(LoginActivity.DEVICE_REG, false);
        intent.putExtra(LoginActivity.ERROR_CODE, error);
        this.startActivity(intent);
    }

    private void handleDevReg() {
        Intent intent = new Intent(this, LoginActivity.class);
        intent.putExtra(LoginActivity.DEVICE_REG, true);
        this.startActivity(intent);
    }

    /**
     * Show the error message when login failed or device registration failed.
     *
     * @param msgcode the error code.
     */
    private void showError(int msgcode) {
        Log.d(Tag, "vpn error code " + msgcode);
        if (Common.VpnError.ERR_WRONG_USER_PASS == msgcode) {
            alert(getString(R.string.error),
                    getString(R.string.user_pwd_error));
        } else if (VpnError.ERR_INTERRUPTED == msgcode) {
            // A user cancelled login or device registration
        } else if (VpnError.ERR_TUN_DOWN == msgcode) {
            // user stop vpn connection from notification area
        } else if (VpnError.ERR_CONFIG_L3VPN == msgcode) {
            // user stop vpn connection from notification area
            alert(getString(R.string.error), "failed to config L3VPN tunnel, please make sure you has vpn permission or stop app and try again");
        } else if ((VpnError.ERR_DEVID_APPROVE_PENDING == msgcode)
                || (VpnError.ERR_DEVID_APPROVE_DENY == msgcode)
                || (VpnError.ERR_DEVID_USER_LIMIT == msgcode)
                || (VpnError.ERR_DEVID_DEV_LIMIT == msgcode)
                || (VpnError.ERR_DEVID_UNREG == msgcode)) {
            // Show device registration errors
            String[] msg = VPNManager.getInstance().getErrorInfo(msgcode);
            alert(msg[1], msg[0]);
        } else if (VpnError.ERR_CALLBACK_FAILED == msgcode) {
            // Do nothing
        } else if ((msgcode >= VpnError.ERR_CERT_NO)
                && (msgcode <= VpnError.ERR_CERT_SERVER_REVOKED)) {
            // Show certificate errors
            String[] msg = VPNManager.getInstance().getErrorInfo(msgcode);
            alert(msg[0], msg[1]);
        } else {
            alert(getString(R.string.error),
                    getString(R.string.network_error));
        }
    }

    /**
     * Show a message dialog.
     *
     * @param title the title of the dialog
     * @param msg   the message of the dialog
     */
    private void alert(String title, String msg) {
        if (title.isEmpty() || msg.isEmpty()) {
            return;
        }
        if (isFinishing()) {
            return;
        }
        new AlertDialog.Builder(this).setTitle(title).setMessage(msg)
                .setIcon(android.R.drawable.ic_dialog_info)
                .setNeutralButton(R.string.ok, null).show();
    }

    private class StartVpnThread extends Thread {
        String mHost;
        int mPort;
        String mUserName;
        String mPassword;
        String mCertPath;
        String mCertPass;
        int mFlag;

        public StartVpnThread(String host, int port, String username,
                              String password, String certpath, String certpass, int flag) {
            mHost = host;
            mPort = port;
            mUserName = username;
            mPassword = password;
            mCertPath = certpath;
            mCertPass = certpass;
            mFlag = flag;
        }

        public void run() {
            VPNManager.getInstance().startVPN(mHost, mPort, mUserName,
                    mPassword, mCertPath, mCertPass, mFlag);
        }
    }
}