package net.vpnsdk.vpn;

import java.util.ArrayList;

public class ArrayAuthInput {
	public final static String method = "method";
	public final static String username = "username";
	public final static String f1 = "f1";
	public final static String f2 = "f2";
	public final static String f3 = "f3";
	public final static String devid = "devid";
	public final static String devname = "devname";
	public final static String delimeter = ";";
	public final static String kv_delimeter = ":";
	public final static String semicolon = "\"";
	public final static String canceled = "error:\"canceled\"";

	private String mMethod;
	private String mUsername = "";
	private String mPassword = "";
	private String mPassword2 = "";
	private String mPassword3 = "";
	private String mDevid = "";
	private String mDevname = "";
	private boolean mCanceled = false;
	private ArrayList<ServerAndPassword> mServerAndPassword = new ArrayList<ServerAndPassword>();
	
	public String composeInput() {
		String res = "";
		
		if (mCanceled) {
			res += canceled;
			return res;
		}
		if ((mMethod != null) && (!mMethod.isEmpty())) {
			res += method + kv_delimeter + semicolon + getMethod() + semicolon + delimeter;
		}
		if ((mUsername != null) && (!mUsername.isEmpty())) {
			res += username + kv_delimeter + semicolon + getUsername() + semicolon + delimeter;
		}
		if ((mPassword != null) && (!mPassword.isEmpty())) {
			res += f1 + kv_delimeter + semicolon + getPassword() + semicolon + delimeter;
		}
		if ((mPassword2 != null) && (!mPassword2.isEmpty())) {
			res += f2 + kv_delimeter + semicolon + getPassword2() + semicolon + delimeter;
		}
		if ((mPassword3 != null) && (!mPassword3.isEmpty())) {
			res += f3 + kv_delimeter + semicolon + getPassword3() + semicolon + delimeter;
		}
		if ((mDevid != null) && (!mDevid.isEmpty())) {
			res += devid + kv_delimeter + semicolon + getDevid() + semicolon + delimeter;
		}
		if ((mDevname != null) && (!mDevname.isEmpty())) {
			res += devname + kv_delimeter + semicolon + getDevname() + semicolon + delimeter;
		}

		return res;
	}

	public String getMethod() {
		return mMethod;
	}

	public void setMethod(String method) {
		mMethod = method;
	}

	public String getUsername() {
		return mUsername;
	}

	public void setUsername(String username) {
		mUsername = username;
	}

	public String getPassword() {
		return mPassword;
	}

	public void setPassword(String password) {
		mPassword = password;
	}

	public String getPassword2() {
		return mPassword2;
	}

	public void setPassword2(String password2) {
		mPassword2 = password2;
	}

	public String getPassword3() {
		return mPassword3;
	}

	public void setPassword3(String password3) {
		mPassword3 = password3;
	}

	public String getDevid() {
		return mDevid;
	}

	public void setDevid(String devid) {
		mDevid = devid;
	}

	public String getDevname() {
		return mDevname;
	}

	public void setDevname(String devname) {
		mDevname = devname + "|" + android.os.Build.MANUFACTURER + ";" + android.os.Build.MODEL + ";Android " + android.os.Build.VERSION.RELEASE;
	}
	
	public boolean getCanceled() {
		return mCanceled;
	}
	
	public void setCanceled(boolean canceled) {
		mCanceled = canceled;
	}
	
	public void clearServerAndPassword() {
		mServerAndPassword.clear();
	}
	
	public int getPasswordCount() {
		return mServerAndPassword.size();
	}
	
	public void addServerAndPassword(ServerAndPassword sp) {
		mServerAndPassword.add(sp);
	}
	
	public ServerAndPassword getServerAndPassword(int index) {
		return mServerAndPassword.get(index);
	}
	
	public static class ServerAndPassword {
		public String Server;
		public String Password;
		public boolean IsChanged = false;
		
		public ServerAndPassword(String server, String password) {
			Server = server;
			Password = password;
		}
	}
}
