package net.vpnsdk.vpn;

final class NativeLib {
    public static final int VPN_RESOURCE_EXCLUDEDCLIENTSUBNET = 0x00000002;

    public static native int start(String host, int port, String alias,
                                   String method, String user, String pass, String pass2,
                                   String pass3, String session, String validcode, String devid, String devname,
                                   String certpath, String certpass, String jcertdata,
                                   int jcertdata_len, boolean udp, boolean encrypt, int disp,
                                   int reconn_count, int reconn_max_time, int flags, String ext2, String client_info, Object obj);

    public static int start(String host, int port, String alias, String user,
                            String pass, String devid, boolean udp, boolean encrypt, int disp,
                            int reconn_count, int reconn_max_time, int flags, Object obj) {

        return start(host, port, alias, null, user, pass, null, null, null,
                null, devid, "", null, null, null, 0, udp, encrypt, disp,
                reconn_count, reconn_max_time, flags, "", "", obj);
    }

    public static native int start2(String host, int port, String alias,
                                    String method, String user, String pass, String pass2,
                                    String pass3, String session, String validcode, String devid, String devname, String hardwareid,
                                    String certpath, String certpass, String jcertdata,
                                    int jcertdata_len, boolean udp, boolean encrypt, int disp,
                                    int reconn_count, int reconn_max_time, int svrtype, int flags, int[] timeout_arr, String lastSessionId, String ext2, String client_info, String clientid, Object obj);

    public static native int start3(String host, int port, String alias,
                                    String method, String user, String pass, String pass2,
                                    String pass3, String session, String validcode, String devid, String devname, String hardwareid,
                                    String certpath, String certpass, String jcertdata,
                                    int jcertdata_len, boolean udp, boolean encrypt, int disp,
                                    int reconn_count, int reconn_max_time, int svrtype, int flags, int[] timeout_arr, String lastSessionId, String ext2, String client_info, String clientid,int sm2, Object obj);

    public static native int setSslProtocol(int sslProtocol);

    public static native String simEnumDev();

    public static native String simEnumApp(String devName);

    public static native String simEnumContainer(String appName);

    public static native int simCheckPinKey(String pinkey);

    public static native int simSetInfo(String devName,String appName,String containerName,String pinkey);

    public static native int isPinKey();

    public static native int stop();

    public static native int setLogLevel(int level, int flags);

    public static native int getStatus();

    public static native long[] getStats();

    public static native int[] tcpProxyEntryCreate(String host, int port, int jvport);

    public static native int[] udpProxyEntryCreate(String host, int port);

    public static native int tcpProxyEntryClose(String vip, int vport);

    public static native int udpProxyEntryClose(String vip, int vport);

    public static native int httpProxyGetPort();

    public static native String getSessionCookie();

    public static native String getHeaderInfo(String key);

    public static native String getSessionId();

    public static native String getUsername();

//    public static native String getClientId();

    public static native void logout();

//    public static native int initDns(String[] arrHostname, String[] arrAddress);

//    public static native void clearDns();

    public static native String[] getIfconfig() throws IllegalArgumentException;

    /**
     * 国密版本 扫码支持接口 输入是url和random随机数
     * url格式：https://119.79.235.134:16606/MAuthServer/qrcode/getQrcode.do?business=infosec&random=dsjljogdadsgg456e4h5e56ehw64h5e20200324091520
     * random格式(32位字母或数字随机字符串加时间戳YYYYMMDDHHMMSS):dsjljogdadsgg456e4h5e56ehw64h5e20200324091520
     * 可使用getRandomStr
     * @param url
     * @param randomStr 随机数字符串，格式(32位字母或数字随机字符串加时间戳YYYYMMDDHHMMSS):dsjljogdadsgg456e4h5e56ehw64h5e20200324091520
     * @param vip AG站点名
     * @param vport AG站点端口
     * @return
     */
    public static native String getQRCode(String url, String randomStr, String vip, int vport);

    public static native int getResourceFlags();

    public static native int getServerIP();

    public static native String[] getHostConnTime(String host, int port);

    static {
        System.loadLibrary("vpn");
        if(SDKConfig.IS_SKF){
            System.loadLibrary("CissSkfApi");
        }
    }
}
